PRO nilc_apply_weights, nodecomp = nodecomp


  ; Authors: 
  ; version 1: Juan Macias Perez -- 08 JAN 2015
  ; version 2: Mathieu Remazeilles -- 14 JAN 2015

  beam=['GAUSSIAN-33.102652-arcmin',$
        'GAUSSIAN-27.943486-arcmin',$
        'GAUSSIAN-13.076460-arcmin',$
        'GAUSSIAN-9.6500000-arcmin',$
        'GAUSSIAN-7.2500000-arcmin',$ 
        'GAUSSIAN-4.9900000-arcmin',$
        'GAUSSIAN-4.8200000-arcmin',$
        'GAUSSIAN-4.6800000-arcmin',$ 
        'GAUSSIAN-4.3300000-arcmin']

  tmpdir = '/data/macias/tmp/'
  indir ='/data/macias/WPI/DX11d/NILC/DX11d_fsky98percent/'

  READ_FITS_MAP,indir+'galactic_mask_0.98_sky_fraction.fits',galmask ; NILC mask DX11d
  nside=GET_NSIDE(galmask)

  saved_bands= indir+'NILC_bands.sav' ; NILC bands

  ;; NILC weights definitions
  ;;-------------
  saved_weights=indir+['weightsdeltaDX11d_0_full.sav','weightsdeltaDX11d_1_full.sav','weightsdeltaDX11d_2_full.sav','weightsdeltaDX11d_3_full.sav','weightsdeltaDX11d_4_full.sav','weightsdeltaDX11d_5_full.sav','weightsdeltaDX11d_6_full.sav','weightsdeltaDX11d_7_full.sav','weightsdeltaDX11d_8_full.sav','weightsdeltaDX11d_9_full.sav']

  
  ;; Read NEEDLET window functions
  RESTORE,saved_bands,/v        ; NILC bands
  nbands = n_elements(bands[0,*])
  FILE_DELETE,tmpdir+'wavelet_output.fits',/allow_nonexistent,/quiet
  MWRFITS, bands, tmpdir+'wavelet_output.fits', /create

  nside_channels=[1024,1024,1024,2048,2048,2048,2048,2048,2048] ; nside of LFI and HFI channel maps
  lmax=2L*nside_channels        ; lmax of channel maps
  l_max=[367,736,1840,3682,4096,4096,4096,4096,4096,4096] ; lmax of NILC bands
  nmap = n_elements(nside_channels)

  channels=[30,44,70,100,143,217,353,545,857]*1d9
;  calfact = 1.0/[1.0,1.0,1.0,1.0,1.0,1.0,1.0,58.035562,2.2681262]; UNIT CONVERSION FACTORS TO HAVE EVERYTHING IN KCMB
  calfact = 1.0/[1.0,1.0,1.0,1.0,1.0,1.0,1.0,57.0403,1.43240] ; UNIT CONVERSION FACTORS TO HAVE EVERYTHING IN KCMB
; Define maps
  map_info = {map_info, suff: '', survey: '', detset: 'GHz', type: '_', comp: 'TSZ'}


  farr = ['30','44','70','100','143','217','353','545','857']
  dir0='/data/dmc/MISS03/DATA/MAP1024_LFI_DX11D/'
  dir = '/data/dmc/MISS03/DATA/MAP_DX11d'+map_info.type+'2048_GALACTIC_0240_27005/'
  dir2 = '/data/dmc/MISS03/DATA/MAP_DX11c'+map_info.type+'2048_GALACTIC_0240_27005/'
  map_list = [dir0+farr[0]+map_info.detset+'_full_I',dir0+farr[1]+map_info.detset+'_full_I',dir0+farr[2]+map_info.detset+'_full_I',$
              dir+farr[3]+map_info.detset+'_W_TauDeconv_odc_pol_'+map_info.survey+'I' ,$
              dir+farr[4]+map_info.detset+'_W_TauDeconv_odc_pol_'+map_info.survey+'I', $
              dir+farr[5]+map_info.detset+'_W_TauDeconv_odc_pol_'+map_info.survey+'I', $
              dir+farr[6]+map_info.detset+'_W_TauDeconv_odc_'+map_info.survey+'I', $
              dir2+farr[7]+map_info.detset+'_W_TauDeconv_planet_'+map_info.survey+'I', $
              dir2+farr[8]+map_info.detset+'_W_TauDeconv_planet_'+map_info.survey+'I' ]

; channels in  bands
  bandchstart =[0,0,0,3,3,3,3,3,3,3]

; Decompose maps into wavelets
  needlet_ilc = ptrarr(nbands)
  w8 = ptrarr(nbands)
; Read weights
  for iband=0,nbands-1 do begin
     RESTORE,saved_weights[iband],/v ; NILC weights band
     w8[iband] = ptr_new(w_sz)
  endfor

  FOR imap=0, nmap-1 DO BEGIN   ; loop on  channels

     if not keyword_Set(nodecomp) then begin

        dummy = pioreadmapobject(map,map_list[imap],'PIODOUBLE','')
 
        ; Be sure that maps are all in RING ordering

        nsidemap=GET_NSIDE(map)

        ;; Degrade NILC mask to the nside of the map, and mask the map
        ;;------------------------------------------------------------       
        UD_GRADE, galmask, galmask, nside_out=nsidemap, order_in='RING' , order_out='RING'
        ww=WHERE(galmask GT 0.)
        map[ww]=map[ww]-AVG(map[ww])
        map=map*galmask


        PSM_MAP2ALM, map, alm, /double, /overwrite
        IND = DBLARR(lmax[imap]*(lmax[imap]+3.0)/2.0+1.0)  
        i=0L
        FOR l=0L, lmax[imap] DO BEGIN
           FOR m=0L, l DO BEGIN
              IND[i]=LONG(l)^2+LONG(l)+LONG(m)+1L
              i=i+1L
           ENDFOR
        ENDFOR  
        INDEX2LM,IND,ll,mm

                                

        ;; filter out alms
        bl_newbeam=PSM_GET_BL(10., lmax=lmax[imap], /double) ; NILC beam (10 arcmin)
        bl=PSM_GET_BL(beam[imap], lmax=lmax[imap], /double) ; Native beam of the map
        bl[WHERE(bl[*] LT 1.e-3)]=1.e-3

        alm[*,0] = alm[*,0]*bl_newbeam[ll]/bl[ll]                   
        alm[*,1]= alm[*,1]*bl_newbeam[ll]/bl[ll]    

       ;; compute wavelet decomposition
        if imap le 2 then relevant_band_max = 2
;        if imap gt 3 and imap le 7 then relevant_band_max = 9
        if imap ge 3 and imap le 7 then relevant_band_max = 9
        if imap eq 8 then relevant_band_max = 5
        FILE_DELETE,tmpdir+'wavelet_temp_'+strtrim(imap,2)+'.fits',/allow_nonexistent,/quiet
        ALM2WAVELETS, TEMPORARY(alm),tmpdir+'wavelet_temp_'+strtrim(imap,2)+'.fits', signal='T', bands=bands, $
                      /overwrite, nside_max_w=2048

     endif

; Read back wavelet decomposition
;        stop


     if imap le 2 then relevant_band_max = 2
;     if imap gt 3 and imap le 7 then relevant_band_max = 9
     if imap ge 3 and imap le 7 then relevant_band_max = 9
     if imap eq 8 then relevant_band_max = 5
     print, "Working on MAP=  ", imap, "    RELEVANT BANDS = "+relevant_band_max

     FOR iband=0, relevant_band_max DO BEGIN

        ;; NILC weights                            
        w_sz = (*w8[iband])

        ;; READ WAVELETS
        tot_needlet=MRDFITS(tmpdir+'/wavelet_temp_'+strtrim(imap,2)+'.fits', iband+1)
        tot_needlet=tot_needlet*calfact[imap] ; convert to K_CMB
        np_band=N_ELEMENTS((tot_needlet))
        nside_band=NPIX2NSIDE(np_band)

 
        ;; NILC weights are all at nside=128 so upgrade to nside of band
        ;;--------------------------------------------------------------
        UD_GRADE, reform(w_sz[*,imap-bandchstart[iband]]), w_sz_map, nside_out=nside_band, order_in='RING',order_out='RING'

        ;; Apply NILC weights onto wavelet maps
        ;;------------------------------------------
        if ptr_valid(needlet_ilc[iband]) eq 0 then begin
           needlet_ilc[iband] = ptr_new(TEMPORARY(w_sz_map)*TEMPORARY(tot_needlet))
        endif else begin
           (*needlet_ilc[iband]) += (TEMPORARY(w_sz_map)*TEMPORARY(tot_needlet))
        endelse
     
     ENDFOR

  ENDFOR

  FOR iband=0,nbands-1 do MWRFITS, (*needlet_ilc[iband]), tmpdir+'wavelet_output.fits'

  WAVELETS2MAP, tmpdir+'wavelet_output.fits', map_out, nside=LONG(nside), polar=0

  MOLLVIEW, map_out, min=-2e-5, max=2e-5

  write_fits_map, tmpdir+'map_nilc_output.fits', map_out, /ring

  ;;------------------------------------------
  stop


END 
